%dw 2.0

type NumberToNumber = (Number) -> Number
type StringToString = (String) -> String

type BooleanType = Boolean
type NameType = String
type NumberType = Number

fun myFunDifArity(name: NameType) = name ++ "Fun1"

fun myFunDifArity(name: NameType, number: NumberType) = name ++ "Fun2"


fun myFunDefaultMethod(name: NameType, number: NumberType=1) = name ++ number

fun myFunDefaultMethod(number1: NumberType, number2: NumberType=2) = number1 + number2


fun fullOverloaded(name: NameType, number: NumberType=1) = name ++ number

fun fullOverloaded(number1: NumberType, number2: NumberType=2) = number1 - number2

fun fullOverloaded(boolean1: BooleanType, boolean2: BooleanType, boolean3: BooleanType) = boolean1 or boolean2 and boolean3


fun callerWithNumber(callback: NumberToNumber) = callback(1)

fun callerWithString(callback: StringToString) = callback("Mariano")

fun dict(stringDict: {_ : NameType}) = stringDict.foo

fun dict(numberDict: {_ : NumberType}) = numberDict.bar

fun a() = "1"
fun a(test) = "2"
fun a(test, test2) = "3"

---
{
    a: myFunDifArity("This is "),
    b: myFunDifArity("This is ", 2),
    c: myFunDefaultMethod("Mariano "),
    d: myFunDefaultMethod("Mariano ", 2),
    e: myFunDefaultMethod(1),
    f: myFunDefaultMethod(1, 4),
    g: fullOverloaded("Shoki"),
    h: fullOverloaded("Shoki", 23),
    i: fullOverloaded(true, true, true),
    j: callerWithNumber(fullOverloaded),
    k: callerWithString(myFunDefaultMethod),
    l: dict({foo: "Mariano"}),
    m: dict({bar: 32}),
    n: a(in0)
}
